var scene, camera, renderer, loader, ambient, directionalLight;
var object;
var cubeDepth = -6.0;
var objRotX = 0.0;
var objRotY = 0.0;
var objRotZ = 0.0;


function setDepth(depth) {
	cubeDepth += depth;
}

function setRotX(x) {
	objRotX = x;
}

function setRotY(y) {
	objRotY = y;
}

function setRotZ(z) {
	objRotZ = z;
}

function ThreeJSInit() {
	container = document.getElementById("glcanvas");
    canvasWidth = container.clientWidth;
    canvasHeight = container.clientHeight;

	scene = new THREE.Scene();
	camera = new THREE.PerspectiveCamera( 70, canvasWidth / canvasHeight, 1, 10000 );
	renderer = new THREE.WebGLRenderer();

	renderer.setSize( canvasWidth, canvasHeight );
	renderer.setClearColor(0xFFFFFF, 1);

	container.appendChild( renderer.domElement );
	
	// PLANE
	var material = new THREE.LineBasicMaterial( { color: 0x303030 } );
	var geometry = new THREE.Geometry();
	var floor = -0.04, step = 1, size = 14;

	for ( var i = 0; i <= size / step * 2; i ++ ) {

		geometry.vertices.push( new THREE.Vector3( - size, floor, i * step - size ) );
		geometry.vertices.push( new THREE.Vector3(   size, floor, i * step - size ) );
		geometry.vertices.push( new THREE.Vector3( i * step - size, floor, -size ) );
		geometry.vertices.push( new THREE.Vector3( i * step - size, floor,  size ) );

	}
	var line = new THREE.Line( geometry, material, THREE.LinePieces );
	line.position.y = -3;
	scene.add( line );

	// MODEL
	var loader = new THREE.OBJMTLLoader();
	loader.load( 'pumpkin/pump.OBJ', 'pumpkin/pump.mtl', function ( event ) {
		object = event;
		object.traverse(function(child) {
			if (child instanceof THREE.Mesh) {
				child.geometry.computeVertexNormals();
			}	
		});		
		object.rotation.order='ZYX';
		scene.add( object );
		animate();
	});

	// FOG
	var fog = new THREE.Fog(0xFFFFFF, 0.3, 20.0);
	scene.fog = fog;

	// LIGHT
	ambient = new THREE.AmbientLight( 0xFFF4F2 );
	scene.add( ambient );

	directionalLight = new THREE.DirectionalLight( 0xFFFFFF );
	directionalLight.position.set( 0, 80, 20 );
	scene.add( directionalLight );

	scene.position.x = 0;
	scene.position.y = 0;
	scene.position.z = 0;

	camera.position.set( 0, 0, 5 );
	camera.lookAt(scene.position);
}

function render() {
	renderer.render(scene, camera);
}

function animate() {
	object.rotation.x = objRotX;
	object.rotation.y = objRotY;
	object.rotation.z = objRotZ;

	requestAnimationFrame( animate );
	render();
}

